Package org.zkoss.zul

## Class Slider

- java.lang.Object
- - org.zkoss.zk.ui.AbstractComponent
  - - org.zkoss.zk.ui.HtmlBasedComponent
    - - org.zkoss.zul.impl.XulElement
      - - org.zkoss.zul.Slider

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Cloneable`, `Component`, `Scope`, `ComponentCtrl`

      public class Slider
      extends XulElement

  A slider.

  Default `getZclass()`: z-slider.

  Author:
    tomyeh
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.zkoss.zk.ui.HtmlBasedComponent

      `HtmlBasedComponent.ExtraCtrl`

    - ### Nested classes/interfaces inherited from class org.zkoss.zk.ui.AbstractComponent

      `AbstractComponent.Children, AbstractComponent.ForwardInfo, AbstractComponent.TargetInfo`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.String` | `DECIMAL` | Represent decimal slider.
    `static java.lang.String` | `INTEGER` | Represent integer slider.

    - ### Fields inherited from class org.zkoss.zk.ui.HtmlBasedComponent

      `_zclass`

    - ### Fields inherited from interface org.zkoss.zk.ui.Component

      `APPLICATION_SCOPE, COMPONENT_SCOPE, DESKTOP_SCOPE, PAGE_SCOPE, REQUEST_SCOPE, SESSION_SCOPE, SPACE_SCOPE`

    - ### Fields inherited from interface org.zkoss.zk.ui.sys.ComponentCtrl

      `AFTER_CHILD_ADDED, AFTER_CHILD_REMOVED, AFTER_CLONED, AFTER_PAGE_ATTACHED, AFTER_PAGE_DETACHED, AFTER_PARENT_CHANGED, CE_BUSY_IGNORE, CE_DUPLICATE_IGNORE, CE_IMPORTANT, CE_NON_DEFERRABLE, CE_REPEAT_IGNORE`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Slider()` |
    `Slider​(int curpos)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `double` | `getAngleArc()` | Returns the degree of arc of the knob slider.
    `int` | `getCurpos()` | Returns the current position of the slider.
    `double` | `getCurposInDouble()` | Returns the double value of slider's current position.
    `int` | `getMaxpos()` | Returns the maximum position of the slider.
    `double` | `getMaxposInDouble()` | Returns the double value of slider's maximum position.
    `int` | `getMinpos()` | Returns the minimum position of the slider.
    `double` | `getMinposInDouble()` | Returns the double value of slider's minimum position.
    `java.lang.String` | `getName()` | Returns the name of this component.
    `java.lang.String` | `getOrient()` | Returns the orient.
    `int` | `getPageIncrement()` | Returns the amount that the value of `getCurpos()` changes by when the tray of the scroll bar is clicked.
    `double` | `getPageIncrementInDouble()` | Returns the amount that the value of `getCurpos()` changes by when the tray of the scroll bar is clicked.
    `double` | `getScaleInput()` | Returns the scale ratio of the input in knob mold.
    `java.lang.String` | `getSlidingtext()` | Returns the sliding text.
    `int` | `getStep()` | Returns the step of slider
    `double` | `getStepInDouble()` | Returns the step of slider
    `double` | `getStrokeWidth()` | Returns the stroke width of the knob slider.
    `java.lang.String` | `getZclass()` | Returns the ZK Cascading Style class for this component.
    `protected boolean` | `isChildable()` | Not childable.
    `boolean` | `isDecimal()` | Returns whether it is a decimal slider.
    `boolean` | `isVertical()` | Returns whether it is a vertical slider.
    `protected void` | `renderProperties​(ContentRenderer renderer)` | Renders the content of this component, excluding the enclosing tags and children.
    `void` | `service​(AuRequest request, boolean everError)` | Processes an AU request.
    `void` | `setAngleArc​(double angleArc)` | Sets the degree of arc for the knob slider.
    `void` | `setCurpos​(double curpos)` | Sets the current position of the slider.
    `void` | `setCurpos​(int curpos)` | Sets the current position of the slider.
    `void` | `setMaxpos​(double maxpos)` | Sets the maximum position of the slider.
    `void` | `setMaxpos​(int maxpos)` | Sets the maximum position of the slider.
    `void` | `setMinpos​(double minpos)` | Sets the minimum position of the slider.
    `void` | `setMinpos​(int minpos)` | Sets the minimum position of the slider.
    `void` | `setMode​(java.lang.String mode)` | Sets the mode.
    `void` | `setMold​(java.lang.String mold)` | Sets the mold.
    `void` | `setName​(java.lang.String name)` | Sets the name of this component.
    `void` | `setOrient​(java.lang.String orient)` | Sets the orient.
    `void` | `setPageIncrement​(double pginc)` | Sets the amount that the value of `getCurpos()` changes by when the tray of the scroll bar is clicked.
    `void` | `setPageIncrement​(int pginc)` | Sets the amount that the value of `getCurpos()` changes by when the tray of the scroll bar is clicked.
    `void` | `setRange​(double minpos, double maxpos)` | Sets the range of slider.
    `void` | `setRange​(int minpos, int maxpos)` | Sets the range of slider.
    `void` | `setScaleInput​(double scaleInput)` | Sets the scale ratio of the input in knob mold.
    `void` | `setSlidingtext​(java.lang.String slidingtext)` | Sets the sliding text.
    `void` | `setStep​(double step)` | Sets the step of slider
    `void` | `setStep​(int step)` | Sets the step of slider
    `void` | `setStrokeWidth​(double strokeWidth)` | Sets the stroke width of the knob slider.

    - ### Methods inherited from class org.zkoss.zul.impl.XulElement

      `clone, getContext, getCtrlKeys, getPopup, getPropertyAccess, getTooltip, setContext, setContext, setContextAttributes, setCtrlKeys, setPopup, setPopup, setPopupAttributes, setTooltip, setTooltip, setTooltipAttributes`

    - ### Methods inherited from class org.zkoss.zk.ui.HtmlBasedComponent

      `addSclass, evalCSSFlex, focus, getAction, getClientAction, getDraggable, getDroppable, getExtraCtrl, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTabindexInteger, getTooltiptext, getTop, getVflex, getWidth, getZindex, getZIndex, removeSclass, removeSclass, setAction, setClass, setClientAction, setDraggable, setDroppable, setFocus, setHeight, setHeight0, setHeightDirectly, setHflex, setHflex0, setHflexDirectly, setLeft, setLeftDirectly, setRenderdefer, setSclass, setStyle, setTabindex, setTabindex, setTooltiptext, setTop, setTopDirectly, setVflex, setVflex0, setVflexDirectly, setWidth, setWidth0, setWidthDirectly, setZclass, setZindex, setZIndex, setZIndexDirectly`

    - ### Methods inherited from class org.zkoss.zk.ui.AbstractComponent

      `addAnnotation, addCallback, addClientEvent, addEventHandler, addEventListener, addEventListener, addForward, addForward, addForward, addForward, addMoved, addRedrawCallback, addScopeListener, addShadowRoot, addShadowRootBefore, addSharedEventHandlerMap, appendChild, applyProperties, beforeChildAdded, beforeChildRemoved, beforeParentChanged, destroyIndexCacheMap, detach, didActivate, didActivate, didDeserialize, didDeserialize, disableBindingAnnotation, disableClientUpdate, disableHostChanged, enableBindingAnnotation, enableHostChanged, getAnnotatedProperties, getAnnotatedPropertiesBy, getAnnotation, getAnnotations, getAnnotations, getAttribute, getAttribute, getAttribute, getAttributeOrFellow, getAttributes, getAttributes, getAuService, getAutag, getCallback, getChildren, getClientAttribute, getClientDataAttribute, getClientEvents, getDefaultMold, getDefinition, getDesktop, getEventHandler, getEventHandlerNames, getEventListenerMap, getEventListeners, getFellow, getFellow, getFellowIfAny, getFellowIfAny, getFellows, getFirstChild, getForwards, getId, getIndexCacheMap, getLastChild, getMold, getNextSibling, getPage, getParent, getPreviousSibling, getRedrawCallback, getRoot, getShadowFellowIfAny, getShadowRoots, getShadowVariable, getShadowVariable, getShadowVariable0, getSpaceOwner, getSpecialRendererOutput, getStubonly, getSubBindingAnnotationCount, getTemplate, getTemplateNames, getUuid, getWidgetAttributeNames, getWidgetClass, getWidgetListener, getWidgetListenerNames, getWidgetOverride, getWidgetOverrideNames, hasAttribute, hasAttribute, hasAttribute, hasAttributeOrFellow, hasBindingAnnotation, hasFellow, hasFellow, hasSubBindingAnnotation, initIndexCacheMap, insertBefore, invalidate, isDisabledHostChanged, isInitialized, isInvalidated, isListenerAvailable, isVisible, onChildAdded, onChildRemoved, onPageAttached, onPageDetached, onParentChanged, onWrongValue, query, queryAll, redraw, redrawChildren, removeAttribute, removeAttribute, removeAttribute, removeCallback, removeChild, removeEventListener, removeForward, removeForward, removeRedrawCallback, removeScopeListener, removeShadowRoot, render, render, render, renderPropertiesOnly, replace, response, response, response, service, sessionDidActivate, sessionWillPassivate, setAttribute, setAttribute, setAttribute, setAuService, setAutag, setClientAttribute, setClientDataAttribute, setDefinition, setDefinition, setId, setPage, setPageBefore, setParent, setStubonly, setStubonly, setSubBindingAnnotationCount, setTemplate, setVisible, setVisibleDirectly, setWidgetClass, setWidgetListener, setWidgetOverride, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdateWidgetListener, smartUpdateWidgetOverride, toString, updateByClient, updateSubBindingAnnotationCount, willPassivate, willPassivate, willSerialize, willSerialize`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### INTEGER

          public static final java.lang.String INTEGER

      Represent integer slider.
      Since:
        7.0.1
      See Also:
        Constant Field Values

    - #### DECIMAL

          public static final java.lang.String DECIMAL

      Represent decimal slider.
      Since:
        7.0.1
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### Slider

          public Slider()

    - #### Slider

          public Slider​(int curpos)

      Parameters:
        `curpos` - the current position (default: 0)

  - ### Method Detail

    - #### getZclass

          public java.lang.String getZclass()

      Description copied from class: `HtmlBasedComponent`
      Returns the ZK Cascading Style class for this component. It usually depends on the implementation of the mold (`AbstractComponent.getMold()`).

      Default: null (the default value depends on element).

      `HtmlBasedComponent.setZclass(java.lang.String)`) will completely replace the default style of a component. In other words, the default style of a component is associated with the default value of `HtmlBasedComponent.getZclass()`. Once it is changed, the default style won't be applied at all. If you want to perform small adjustments, use `HtmlBasedComponent.setSclass(java.lang.String)` instead.

      Overrides:
        `getZclass` in class `HtmlBasedComponent`
      See Also:
        `HtmlBasedComponent.getSclass()`

    - #### getOrient

          public java.lang.String getOrient()

      Returns the orient.

      Default: "horizontal".

    - #### setOrient

          public void setOrient​(java.lang.String orient)
                         throws WrongValueException

      Sets the orient.

      Default : "horizontal"

      Parameters:
        `orient` - either "horizontal" or "vertical".
      Throws:
        `WrongValueException`
      Since:
        3.5.0

    - #### getSlidingtext

          public java.lang.String getSlidingtext()

      Returns the sliding text.

      Default : "{0}"

      Since:
        3.0.1

    - #### setSlidingtext

          public void setSlidingtext​(java.lang.String slidingtext)

      Sets the sliding text. The syntax "{0}" will be replaced with the position at client side.
      Since:
        3.0.1

    - #### getCurpos

          public int getCurpos()

      Returns the current position of the slider.

      Default: 0.

    - #### getCurposInDouble

          public double getCurposInDouble()

      Returns the double value of slider's current position.

      Default: 0.

      Since:
        7.0.1

    - #### setCurpos

          public void setCurpos​(int curpos)

      Sets the current position of the slider. If negative, 0 is assumed. If larger than `getMaxpos()`, `getMaxpos()` is assumed.

    - #### setCurpos

          public void setCurpos​(double curpos)
                         throws WrongValueException

      Sets the current position of the slider. If negative, 0 is assumed. If larger than `getMaxpos()`, `getMaxpos()` is assumed.
      Throws:
        `WrongValueException`
      Since:
        7.0.1

    - #### getMinpos

          public int getMinpos()

      Returns the minimum position of the slider.

      Default: 0.

    - #### getMinposInDouble

          public double getMinposInDouble()

      Returns the double value of slider's minimum position.

      Default: 0.

      Since:
        7.0.1

    - #### setMinpos

          public void setMinpos​(int minpos)

      Sets the minimum position of the slider.
      Throws:
        `WrongValueException` - if non-positive minimum is passed

    - #### setMinpos

          public void setMinpos​(double minpos)
                         throws WrongValueException

      Sets the minimum position of the slider.
      Throws:
        `WrongValueException` - if non-positive minimum is passed
      Since:
        7.0.1

    - #### getMaxpos

          public int getMaxpos()

      Returns the maximum position of the slider.

      Default: 100.

    - #### getMaxposInDouble

          public double getMaxposInDouble()

      Returns the double value of slider's maximum position.

      Default: 100.

      Since:
        7.0.1

    - #### setMaxpos

          public void setMaxpos​(int maxpos)

      Sets the maximum position of the slider.
      Throws:
        `WrongValueException` - if non-positive maxpos is passed

    - #### setMaxpos

          public void setMaxpos​(double maxpos)
                         throws WrongValueException

      Sets the maximum position of the slider.
      Throws:
        `WrongValueException` - if non-positive maxpos is passed
      Since:
        7.0.1

    - #### isVertical

          public boolean isVertical()

      Returns whether it is a vertical slider.
      Since:
        3.5.0

    - #### getPageIncrement

          public int getPageIncrement()

      Returns the amount that the value of `getCurpos()` changes by when the tray of the scroll bar is clicked.

      Default: -1 (means it will scroll to the position the user clicks).

    - #### getPageIncrementInDouble

          public double getPageIncrementInDouble()

      Returns the amount that the value of `getCurpos()` changes by when the tray of the scroll bar is clicked.

      Default: -1 (means it will scroll to the position the user clicks).

      Since:
        7.0.1

    - #### setPageIncrement

          public void setPageIncrement​(int pginc)

      Sets the amount that the value of `getCurpos()` changes by when the tray of the scroll bar is clicked.

      Default: -1 (means it will scroll to the position the user clicks).

      Parameters:
        `pginc` - the page increment. If negative, slider will scroll to the position that user clicks.

    - #### setPageIncrement

          public void setPageIncrement​(double pginc)
                                throws WrongValueException

      Sets the amount that the value of `getCurpos()` changes by when the tray of the scroll bar is clicked.

      Default: -1 (means it will scroll to the position the user clicks).

      Parameters:
        `pginc` - the page increment. If negative, slider will scroll to the position that user clicks.
      Throws:
        `WrongValueException`
      Since:
        7.0.1

    - #### getStep

          public int getStep()

      Returns the step of slider

      Default: -1 (means it will scroll to the position the user clicks). Note: In "decimal" mode, the fraction part only contains one digit if step is -1.

      Since:
        7.0.1

    - #### getStepInDouble

          public double getStepInDouble()

      Returns the step of slider

      Default: -1 (means it will scroll to the position the user clicks). Note: In "decimal" mode, the fraction part only contains one digit if step is -1.

      Since:
        7.0.1

    - #### setStep

          public void setStep​(int step)

      Sets the step of slider
      Parameters:
        `step` - the step of slider. If negative, slider will not step.
      Since:
        7.0.1

    - #### setStep

          public void setStep​(double step)
                       throws WrongValueException

      Sets the step of slider
      Parameters:
        `step` - the step of slider. If negative, slider will not step.
      Throws:
        `WrongValueException`
      Since:
        7.0.1

    - #### getName

          public java.lang.String getName()

      Returns the name of this component.

      Default: null.

      The name is used only to work with "legacy" Web application that handles user's request by servlets. It works only with HTTP/HTML-based browsers. It doesn't work with other kind of clients.

      Don't use this method if your application is purely based on ZK's event-driven model.

      Since:
        3.0.0

    - #### setName

          public void setName​(java.lang.String name)

      Sets the name of this component.

      The name is used only to work with "legacy" Web application that handles user's request by servlets. It works only with HTTP/HTML-based browsers. It doesn't work with other kind of clients.

      Don't use this method if your application is purely based on ZK's event-driven model.

      Parameters:
        `name` - the name of this component.
      Since:
        3.0.0

    - #### setMold

          public void setMold​(java.lang.String mold)

      Sets the mold.
      Specified by:
        `setMold` in interface `Component`
      Overrides:
        `setMold` in class `AbstractComponent`
      Parameters:
        `mold` - default , scale
      See Also:
        `ComponentDefinition`

    - #### setMode

          public void setMode​(java.lang.String mode)

      Sets the mode.

      Default : "integer" Note: Knob mold does not support this method, please use `setStep(double)` instead.

      Parameters:
        `mode` - either "integer" or "decimal".
      Since:
        7.0.1

    - #### isDecimal

          public boolean isDecimal()

      Returns whether it is a decimal slider.
      Since:
        7.0.1

    - #### setRange

          public void setRange​(int minpos,
                               int maxpos)

      Sets the range of slider.
      Parameters:
        `minpos` - the minimum position of the slider.
        `maxpos` - the maximum position of the slider.
      Since:
        7.0.1

    - #### setRange

          public void setRange​(double minpos,
                               double maxpos)

      Sets the range of slider.
      Parameters:
        `minpos` - the minimum position of the slider.
        `maxpos` - the maximum position of the slider.
      Since:
        7.0.1

    - #### setAngleArc

          public void setAngleArc​(double angleArc)

      Sets the degree of arc for the knob slider.

      Default : 360.0

      Parameters:
        `angleArc` - is the degree of arc of the knob slider. The unit is degrees (360° for a circle).
      Since:
        8.6.0

    - #### getAngleArc

          public double getAngleArc()

      Returns the degree of arc of the knob slider.

      Default: 360.0

      Returns:
        double
      Since:
        8.6.0

    - #### setStrokeWidth

          public void setStrokeWidth​(double strokeWidth)

      Sets the stroke width of the knob slider.

      Default: 10.0

      Parameters:
        `strokeWidth` - is the stroke width for the knob slider
      Since:
        8.6.0

    - #### getStrokeWidth

          public double getStrokeWidth()

      Returns the stroke width of the knob slider.

      Default: 10.0

      Returns:
        double
      Since:
        8.6.0

    - #### setScaleInput

          public void setScaleInput​(double scaleInput)

      Sets the scale ratio of the input in knob mold. e.g.: 1.5 This will enlarge or narrow the whole input the scale ratio. Default: 1.0
      Parameters:
        `scaleInput` - is a number in double that scales the input size.
      Since:
        8.6.0

    - #### getScaleInput

          public double getScaleInput()

      Returns the scale ratio of the input in knob mold.
      Returns:
        double
      Since:
        8.6.0

    - #### isChildable

          protected boolean isChildable()

      Not childable.
      Overrides:
        `isChildable` in class `AbstractComponent`

    - #### service

          public void service​(AuRequest request,
                              boolean everError)

      Processes an AU request.

      Default: in addition to what are handled by `HtmlBasedComponent.service(org.zkoss.zk.au.AuRequest, boolean)`, it also handles onOpen.

      Specified by:
        `service` in interface `ComponentCtrl`
      Overrides:
        `service` in class `HtmlBasedComponent`
        `everError` - whether any error ever occurred before processing this request.
      Since:
        5.0.0
      See Also:
        `AbstractComponent.setAuService(org.zkoss.zk.au.AuService)`

    - #### renderProperties

          protected void renderProperties​(ContentRenderer renderer)
                                   throws java.io.IOException

      Description copied from class: `HtmlBasedComponent`
      Renders the content of this component, excluding the enclosing tags and children.

      See also ZK Client-side Reference: Property Rendering

      Overrides:
        `renderProperties` in class `XulElement`
      Throws:
        `java.io.IOException`